<?php

class EvClassRegistry
{
	/**
	 * function to mimic ClassRegistry::init(), but works with our overriding model workflow
	 * Pass PluginName.Model (normal models will work as normal) and it will check PluginNameModel first
	 * then standard PluginName.Model
 	 *
 	 * @param 	String 	Model to load
 	 * @return 	Object 	Model object if found
 	 */
	public static function init($model)
	{
		if (strpos($model, '.') !== false) {

			list($pluginName, $modelName) = pluginSplit($model);

			// first check if we can find an 'overriding model'
			// true parameter will make it return false if none was found

			$Model = ClassRegistry::init($pluginName.$modelName, true);
			if (
				$Model !== false &&
				is_object($Model) &&
				$Model instanceof $pluginName.$modelName
			) {

				// return the model
				return $Model;
			}
		}

		// obviously none was found, try looking in the plugin
		return ClassRegistry::init($model);
	}

}
